<?php
//====================================================================
// awsassist.php
//--------------------------------------------------------------------
// アメンボ: 改変履歴
// 1) 22～431行目
//  アメンボの動作に不要な関数をコメントアウト
//====================================================================
/*
** Date modified: 17th May 2009 02:30 GMT
*
** PHP implementation of the Append Security digest Amazon Web Service Request
*
** This code is available under the GNU Lesser General Public License:
** http://www.gnu.org/licenses/lgpl.txt
*
** Based sha encrypt on the PHP implementation by Marcus Campbell
** http://www.tecknik.net/sha-1/
*
*/

/*
if (!function_exists('aa_hmacsha256') && function_exists('hash'))
{
  if (array_search('sha256',hash_algos())!==FALSE && !defined("AA_HMACSHA256_HASH"))
  {
    function aa_hmacsha256($str, $key, $raw_output=FALSE)
    {
        return hash_hmac('sha256',$str,$key,$raw_output);
    }
  }
}

if (!function_exists('aa_hmacsha256') && function_exists('mhash') && defined("MHASH_SHA256"))
{
  if (mhash(MHASH_SHA256,"test data","test key") !==FALSE) {
    function aa_hmacsha256($str, $key, $raw_output=FALSE)
    {
        $hash = mhash(MHASH_SHA256, $str, $key);
        if ( $raw_output === TRUE ) return $hash;
        return bin2hex($hash);
    }
  }
}

if (!function_exists('aa_hmacsha256')) {
  if (!function_exists('aa_sha256') && function_exists('mhash') && defined("MHASH_SHA256"))
  {
    function aa_sha256($str)
    {
      return mhash(MHASH_SHA256, $str);
    }
  }

  if (!function_exists('aa_sha256'))
  {
*/

    // SHA1 and SHA-256
    function sha_str2blks_512($str)
    {
      $strlen_str = strlen($str);
      
      $nblk = (($strlen_str + 8) >> 6) + 1;
      
      for ($i=0; $i < $nblk * 16; $i++) $blks[$i] = 0;
      
      for ($i=0; $i < $strlen_str; $i++)
      {
        $blks[$i >> 2] |= ord(substr($str, $i, 1)) << (24 - ($i % 4) * 8);
      }
      
      $blks[$i >> 2] |= 0x80 << (24 - ($i % 4) * 8);
      $blks[$nblk * 16 - 1] = $strlen_str * 8;
      
      return $blks;
    }
/*
    // ROTL 32bit
    function sha_rotl($num, $cnt)
    {
      if ($cnt==0) return $num;
      return (($num & (0x7fffffff >> ($cnt - 1))) << $cnt) | (($num >> (32 - $cnt)) & (0x7fffffff >> (32 - $cnt -1)));
    }
*/
    // ROTR 32bit
    function sha_rotr($num, $cnt)
    {
      if ($cnt==0) return $num;
      return (($num >> $cnt) & (0x7fffffff >> ($cnt -1))) | (($num & (0x7fffffff >> (32 - $cnt -1))) << (32- $cnt));
    }

    // SHR 32bit
    function sha_shr($num, $cnt)
    {
      if ($cnt==0) return $num;
      return ($num >> $cnt) & (0x7fffffff >> ($cnt -1));
    }

    // add 32bit integer
    function sha_safe_add($x, $y)
    {
      $lsw = ($x & 0xFFFF) + ($y & 0xFFFF);
      $msw = (($x >> 16) & 0xFFFF) + (($y >> 16) & 0xFFFF) + ($lsw >> 16);
      
      return (($msw & 0xFFFF) << 16) | ($lsw & 0xFFFF);
    }
    function sha_SL256_0($x)
    {
      return sha_rotr($x,2) ^ sha_rotr($x,13) ^ sha_rotr($x,22);
    }
    function sha_SL256_1($x)
    {
      return sha_rotr($x,6) ^ sha_rotr($x,11) ^ sha_rotr($x,25);
    }

    function sha_SS256_0($x)
    {
      return sha_rotr($x,7) ^ sha_rotr($x,18) ^ sha_shr($x,3);
    }

    function sha_SS256_1($x)
    {
      return sha_rotr($x,17) ^ sha_rotr($x,19) ^ sha_shr($x,10);
    }

    function sha_Ch32($x,$y,$z)
    {
      return ($x & $y) ^ ((~$x) & $z);
    }

    function sha_Maj32($x,$y,$z)
    {
      return ($x & $y) ^ ($x & $z) ^ ($y & $z);
    }

    function sha256_kt($t)
    {
      $ar  = "428a2f98 71374491 b5c0fbcf e9b5dba5 3956c25b 59f111f1 923f82a4 ab1c5ed5 ".
             "d807aa98 12835b01 243185be 550c7dc3 72be5d74 80deb1fe 9bdc06a7 c19bf174 ".
             "e49b69c1 efbe4786 0fc19dc6 240ca1cc 2de92c6f 4a7484aa 5cb0a9dc 76f988da ".
             "983e5152 a831c66d b00327c8 bf597fc7 c6e00bf3 d5a79147 06ca6351 14292967 ".
             "27b70a85 2e1b2138 4d2c6dfc 53380d13 650a7354 766a0abb 81c2c92e 92722c85 ".
             "a2bfe8a1 a81a664b c24b8b70 c76c51a3 d192e819 d6990624 f40e3585 106aa070 ".
             "19a4c116 1e376c08 2748774c 34b0bcb5 391c0cb3 4ed8aa4a 5b9cca4f 682e6ff3 ".
             "748f82ee 78a5636f 84c87814 8cc70208 90befffa a4506ceb bef9a3f7 c67178f2";
      $data=explode(" ",$ar,64);
      return hexdec($data[$t]);
    }

    function sha256_init()
    {
      return array(0x6a09e667,0xbb67ae85,0x3c6ef372,0xa54ff53a,0x510e527f,0x9b05688c,0x1f83d9ab,0x5be0cd19);
    }
    function aa_sha256($str)
    {
      $x = sha_str2blks_512($str);
      list($a,$b,$c,$d,$e,$f,$g,$h) = sha256_init();

      $x_count = count($x);

      for ($i = 0; $i < $x_count; $i += 16)
      {
        $olda = $a;
        $oldb = $b;
        $oldc = $c;
        $oldd = $d;
        $olde = $e;
        $oldf = $f;
        $oldg = $g;
        $oldh = $h;

        for ($j = 0; $j < 64; $j++)
        {
          $w[$j] = ($j < 16) ? $x[$i + $j] : sha_safe_add(sha_safe_add(sha_SS256_1($w[$j-2]),$w[$j-7]),sha_safe_add(sha_SS256_0($w[$j-15]),$w[$j-16]));
          
          $t1 = sha_safe_add(sha_safe_add($h, sha_SL256_1($e)), sha_safe_add(sha_safe_add(sha_Ch32($e,$f,$g), $w[$j]), sha256_kt($j)));
          $t2 = sha_safe_add(sha_SL256_0($a), sha_Maj32($a,$b,$c));
          $h = $g;
          $g = $f;
          $f = $e;
          $e = sha_safe_add($d, $t1);
          $d = $c;
          $c = $b;
          $b = $a;
          $a = sha_safe_add($t1, $t2);
        }

        $a = sha_safe_add($a, $olda);
        $b = sha_safe_add($b, $oldb);
        $c = sha_safe_add($c, $oldc);
        $d = sha_safe_add($d, $oldd);
        $e = sha_safe_add($e, $olde);
        $f = sha_safe_add($f, $oldf);
        $g = sha_safe_add($g, $oldg);
        $h = sha_safe_add($h, $oldh);
      }

      return pack('H*', sprintf('%08x%08x%08x%08x%08x%08x%08x%08x', $a, $b, $c, $d, $e, $f, $g, $h));
    }
//}
  function aa_hmacsha256($data,$key,$raw_output=FALSE) {
    $blocksize=64;
    $hashfunc='aa_sha256';
    if (strlen($key)>$blocksize)
    {
        $key=$hashfunc($key);
    }
    $key=str_pad($key,$blocksize,chr(0x00));
    $ipad=str_repeat(chr(0x36),$blocksize);
    $opad=str_repeat(chr(0x5c),$blocksize);

    $step1 = $key^$ipad;
    $step2 = $hashfunc($step1.$data);
    $step3 = $key^$opad;
    $step4 = $hashfunc($step3.$step2);

    $hmac = $step4;

    if ($raw_output) {
        return $hmac;
    }
    return bin2hex($hmac);
  }
/*

}

// url - request url with out parameters(ex,"http://ecs.amazonaws.jp/onca/xml")
// parameters - array of parameters,parameters[key]=value
// key - amazon Secret key
function aa_makesignedrequest($url,$parameters,$SecretKey) {
  $host="";
  $protocol="http";
  $port="80";
  $uri="/";
  $remain=$url;
  $method="GET";

  // analyze protocol
  if (substr($remain,0,7)=="http://") {
    $protocol="http";
    $port="80";
    $remain=substr($remain,7,strlen($remain));
  } elseif (substr($remain,0,8)=="https://") {
    $procotol="https";
    $port="433";
    $remain=substr($remain,8,strlen($remain));
  } else {
    return FALSE;
  }

  // separate host/garget/parameter
  $idx1=strpos($remain,"/");
  $idx2=strpos($remain,"?");
  if ($idx1!==FALSE&&$idx2!==FALSE&&$idx2<$idx1) {
    $idx1=FALSE;
  }

  // analyze host
  if ($idx1!==FALSE||$idx2!==FALSE) {
    $idx=$idx1;
    if ($idx===FALSE) {
      $idx=$idx2;
    }
    $host=substr($remain,0,$idx);
    $remain=substr($remain,$idx,strlen($remain));
  } else {
    $host=$remain;
    $remain="";
  }

  // analyze uri
  if ($idx1!==FALSE) {
    if ($idx2!==FALSE) {
      $idx=strpos($remain,"?");
      $uri=substr($remain,0,$idx);
      $remain=substr($remain,$idx+1,strlen($remain));
    } else {
      $uri=$remain;
      $remain="";
    }
  } else {
    $uri="/";
  }

  if (!array_key_exists("Timestamp",$parameters)) {
    $key="Timestamp";
    $value=gmdate('Y-m-d\TH:i:s\Z');
    $parameters[$key]=$value;
  }

  ksort($parameters);

  $signstring="";
  $signstring.=$method."\n";
  $signstring.=$host."\n";
  $signstring.=$uri."\n";
  $param="";
  foreach ($parameters as $key=>$value) {
    $key=rawurlencode($key);
    $value=rawurlencode($value);
    if ($param!=="") {
      $param.="&";
    }
    $param.=$key."=".$value;
  }
  $signstring.=$param;
  $resulturl="";
  $resulturl.="http://";
  $resulturl.=$host;
  $resulturl.=$uri;
  $resulturl.="?";
  $resulturl.=$param;

  $signature=base64_encode(aa_hmacsha256($signstring,$SecretKey,true));

  $resulturl.="&";
  $resulturl.="Signature=".rawurlencode($signature);

  return $resulturl;
}

// url - request url with out signature and timestamp
// key - Amazon Secret key
function aa_signrequest($url,$SecretKey) {
  $params=array();
  $host="";
  $protocol="http";
  $port="80";
  $uri="/";
  $remain=$url;
  $method="GET";

  // analyze protocol
  if (substr($remain,0,7)=="http://") {
    $protocol="http";
    $port="80";
    $remain=substr($remain,7,strlen($remain));
  } elseif (substr($remain,0,8)=="https://") {
    $procotol="https";
    $port="433";
    $remain=substr($remain,8,strlen($remain));
  } else {
    return FALSE;
  }

  // separate host/garget/parameter
  $idx1=strpos($remain,"/");
  $idx2=strpos($remain,"?");
  if ($idx1!==FALSE&&$idx2!==FALSE&&$idx2<$idx1) {
    $idx1=FALSE;
  }

  // analyze host
  if ($idx1!==FALSE||$idx2!==FALSE) {
    $idx=$idx1;
    if ($idx===FALSE) {
      $idx=$idx2;
    }
    $host=substr($remain,0,$idx);
    $remain=substr($remain,$idx,strlen($remain));
  } else {
    $host=$remain;
    $remain="";
  }

  // analyze uri
  if ($idx1!==FALSE) {
    if ($idx2!==FALSE) {
      $idx=strpos($remain,"?");
      $uri=substr($remain,0,$idx);
      $remain=substr($remain,$idx+1,strlen($remain));
    } else {
      $uri=$remain;
      $remain="";
    }
  } else {
    $uri="/";
  }

  // analyze parameter
  if ($idx2!==FALSE) {
    foreach (explode("&",$remain) as $data) {
      $param=explode("=",$data,2);
      if (is_array($param)) {
        list($key,$value)=$param;
        $key=rawurlencode(urldecode($key));
        $value=rawurlencode(urldecode($value));
        $params[$key]=$value;
      } else {
        // if only parameter name not value,remove it
      }
    }
  }

  if (!array_key_exists("Timestamp",$params)) {
    $key="Timestamp";
    $value=gmdate('Y-m-d\TH:i:s\Z');
    $params[$key]=rawurlencode($value);
  }

  ksort($params);

  $signstring="";
  $signstring.=$method."\n";
  $signstring.=$host."\n";
  $signstring.=$uri."\n";
  $param="";
  foreach ($params as $key=>$value) {
    if ($param!=="") {
      $param.="&";
    }
    $param.=$key."=".$value;
  }
  $signstring.=$param;
  $resulturl="";
  $resulturl.="http://";
  $resulturl.=$host;
  $resulturl.=$uri;
  $resulturl.="?";
  $resulturl.=$param;

  $signature=base64_encode(aa_hmacsha256($signstring,$SecretKey,true));

  $resulturl.="&";
  $resulturl.="Signature=".rawurlencode($signature);

  return $resulturl;
}
*/
?>