<?php
//====================================================================
// Amazon 広告スクリプト: アメンボ
//--------------------------------------------------------------------
// *** AMnBO for BlognPlus***
// LAST UPDATE: 2015/07/11
// Version    : 1.02
// Copyright  : nJOY
// http://i-njoy.net/
//====================================================================

$asin = htmlspecialchars($_GET["asin"]);
preg_match("/^[A-Z0-9]{10}$/", $asin, $match);
if (!$match) exit;

$format = isset($_GET["f"]) ? htmlspecialchars($_GET["f"]) : null;
$user = isset($_GET["u"]) ? htmlspecialchars($_GET["u"]) : null;

include("config.php");

$itemfile = "./tool/".$match["0"].".php";

if ($user == "r") {
	$associate = $blogn_module_amnbo_amaid[array_rand($blogn_module_amnbo_amaid)];
} elseif (array_key_exists($user, $blogn_module_amnbo_amaid)) {
	$associate = $blogn_module_amnbo_amaid["$user"];
} else {
	$associate = $blogn_module_amnbo_amaid["0"];	
}

if (file_exists($itemfile)) {
	include ($itemfile);
	if ((time() - $created) > ($blogn_module_amnbo_tool["refresh"] * 3600)) $product = amnbo_lookup($match["0"], $blogn_module_amnbo_apikey, $blogn_module_amnbo_func, $associate);
} else {
	$product = amnbo_lookup($match["0"], $blogn_module_amnbo_apikey, $blogn_module_amnbo_func, $associate);
}


if (is_array($product)) $output = amnbo_data_output($product, $associate, $format, $blogn_module_amnbo_common, $blogn_module_amnbo_tool);
header("Content-Type: text/html; charset=Utf-8");
echo $output;

function amnbo_lookup($id, $apikey, $func, $associate) {
	$html = "";
	include("request.php");

	$parameters = array(
		"Operation" => "ItemLookup",
		"ItemId" => $id, 
		"ResponseGroup" => "Offers,Images,ItemAttributes,Reviews,Variations"
	);

	$pxml = aws_signed_request("jp", $parameters, $apikey["public"], $apikey["secret"], $func, $associate);

	if ($func["xml"]) {
		$ad = $pxml -> Items -> Item -> ItemAttributes -> IsAdultProduct;
	} else {
		$ad = $pxml["ItemLookupResponse"]["Items"]["Item"]["ItemAttributes"]["IsAdultProduct"];
	}

	if (!$pxml || $ad == 1) return $html;
	
	$product = amnbo_product($pxml, $func["xml"]);
	$product["asin"] = $id;
	$product["off"] = "";
	if ($product["price"]) {
		$yoff = $product["rrp"] - $product["price"];
		if ($yoff > 0 && $product["rrp"]) $product["off"] = round($yoff / $product["rrp"] * 100);
	}
	$product["status"] = (!$product["price"] && !$product["rrp"]) ? "0" : "1";

	$data = '<?php
$created = "'.time().'";
$product = array(';
	foreach ($product as $key => $value) {
    	$data .= '"'.$key.'" => "'.amnbo_format_record($value).'", ';
	}
	$data .= ');
?>';

	$itemfile = "./tool/".$id.".php";
	$fp = @fopen($itemfile,"w");
	flock($fp, LOCK_EX);
	fwrite($fp, $data);
	flock($fp, LOCK_UN);
	fclose($fp);
	
	return $product;
}

function amnbo_product($pxml, $mode) {
	if ($mode) {
		$xml = $pxml -> Items -> Item;
		if ($xml -> ItemAttributes -> ReleaseDate) {
			$release = $xml -> ItemAttributes -> ReleaseDate;
		} elseif ($xml -> ItemAttributes -> PublicationDate) {
			$release = $xml -> ItemAttributes -> PublicationDate;
		}
		if ($release) {
			list($year, $month, $day) = sscanf($release, "%d-%d-%d");
			$release_u = mktime(0, 0, 0, $month, $day, $year);
		}
		if ($xml -> Offers -> Offer -> OfferListing -> Availability) {
			$price = $xml -> Offers -> Offer -> OfferListing -> Price -> Amount;
			$avail = $xml -> Offers -> Offer -> OfferListing -> Availability;
		} elseif ($xml -> VariationSummary) {
			$price = $xml -> VariationSummary -> LowestSalePrice -> Amount;
			$rrp = $xml -> VariationSummary -> LowestPrice -> Amount;
			$avail = "";
		} elseif ($xml -> Offers -> Offer -> OfferListing -> AvailabilityAttributes -> AvailabilityType == "futureDate") {
			$price = $xml -> Offers -> Offer -> OfferListing -> Price -> Amount;
			$avail = "近日入荷（注文可）"; 
		} elseif ($xml -> OfferSummary -> TotalNew != 0) {
			$price = $xml -> OfferSummary -> LowestNewPrice -> Amount;
			$avail = 'マーケットプレイス（新品）';
		} elseif ($xml -> OfferSummary -> TotalUsed != 0) {
			$price = $xml -> OfferSummary -> LowestUsedPrice -> Amount;
			$avail = 'マーケットプレイス（中古）';
		} else {
			$price = "";
			if ($release_u > time()) {
				$avail = "近日予約開始";
			} else {
				$avail = "在庫なし";
			}
		}
		if (strpos($avail, "在庫切れですが")) $avail = "一時的に在庫切れ中";

		$image = preg_replace("/(\._SL500_)*\.jpg$/", "", $xml -> LargeImage -> URL);
		$product["title"] =		$xml -> ItemAttributes -> Title;
		$product["maker"] = 	($xml -> ItemAttributes -> Manufacturer) ? $xml -> ItemAttributes -> Manufacturer : $xml -> ItemAttributes -> Brand;
		$product["rrp"] = 		$rrp ? $rrp : $xml -> ItemAttributes -> ListPrice -> Amount;
		$product["price"] = 	$price;
		$product["release"] = 	$release ? $release : "";
		$product["image"] = 	$image;
		$product["avail"] = 	$avail;
//		$product["rating"] = 	$xml -> CustomerReviews -> AverageRating;
	} else {
		$arr = $pxml["ItemLookupResponse"]["Items"]["Item"];
		if ($arr["ItemAttributes"]["ReleaseDate"]) {
			$release = $arr["ItemAttributes"]["ReleaseDate"];
		} elseif ($arr["ItemAttributes"]["PublicationDate"]) {
			$release = $arr["ItemAttributes"]["PublicationDate"];
		}
		if ($release) {
			list($year, $month, $day) = sscanf($release, "%d-%d-%d");
			$release_u = mktime(0, 0, 0, $month, $day, $year);
		}
		if ($arr["Offers"]["Offer"]["OfferListing"]["Availability"]) {
			$price = $arr["Offers"]["Offer"]["OfferListing"]["Price"]["Amount"];
			$avail = $arr["Offers"]["Offer"]["OfferListing"]["Availability"];
		} elseif ($arr["VariationSummary"]) {
			$price = $arr["VariationSummary"]["LowestSalePrice"]["Amount"];
			$rrp = $arr["VariationSummary"]["LowestPrice"]["Amount"];
			$avail = "";
		} elseif ($arr["Offers"]["Offer"]["OfferListing"]["AvailabilityAttributes"]["AvailabilityType"] == "futureDate") {
			$price = $arr["Offers"]["Offer"]["OfferListing"]["Price"]["Amount"];
			$avail = "近日入荷（注文可）"; 
		} elseif ($arr["OfferSummary"]["TotalNew"] != 0) {
			$price = $arr["OfferSummary"]["LowestNewPrice"]["Amount"];
			$avail = 'マーケットプレイス（新品）';
		} elseif ($arr["OfferSummary"]["TotalUsed"] != 0) {
			$price = $arr["OfferSummary"]["LowestUsedPrice"]["Amount"];
			$avail = 'マーケットプレイス（中古）';
		} else {
			$price = "";
			if ($release_u > time()) {
				$avail = "近日予約開始";
			} else {
				$avail = "在庫なし";
			}
		}
		if (strpos($avail, "在庫切れですが")) $avail = "一時的に在庫切れ中";

		$image = preg_replace("/(\._SL500_)*\.jpg$/", "", $arr["LargeImage"]["URL"]);
		$product["title"] =		$arr["ItemAttributes"]["Title"];
		$product["maker"] = 	$arr["ItemAttributes"]["Manufacturer"] ? $arr["ItemAttributes"]["Manufacturer"] : $arr["ItemAttributes"]["Brand"];
		$product["rrp"] = 		$rrp ? $rrp :$arr["ItemAttributes"]["ListPrice"]["Amount"];
		$product["price"] = 	$price;
		$product["release"] = 	$release ? $release : "";
		$product["image"] = 	$image;
		$product["avail"] = 	$avail;
//		$product["rating"] = 	$arr["CustomerReviews"]["AverageRating"];
	}
	return $product;
}

function amnbo_data_output($product, $associate, $size, $common, $tool) {
	$credit = "";
		$credit = '<a href="http://i-njoy.net/amnbo/" target="'.$common["target"].'" id="credit"><img src="img/amnbo.gif" width="16" height="16" border="0" title="Amazon 広告スクリプト「アメンボ」" alt="Amazon 広告スクリプト「アメンボ」" /></a>';
	$asinlink = 'http://www.amazon.co.jp/exec/obidos/ASIN/'.$product["asin"].'/'.$associate.'/';
/*
	switch ($product["rating"]) { //★
		case "5.0":
			$rating = '5-0';
			break;
		case "4.5":
			$rating = '4-5';
			break;
		case "4.0":
			$rating = '4-0';
			break;
		case "3.5";
			$rating = '3-5';
			break;
		case "3.0";
			$rating = '3-0';
			break;
		case "2.5";
			$rating = '2-5';
			break;
		case "2.0";
			$rating = '2-0';
			break;
		case "1.5";
			$rating = '1-5';
			break;
		case "1.0";
			$rating = '1-0';
			break;
		default:
			$rating = "";
			break;
	}
	if ($rating) $stars = '<br />おすすめ平均: <img src="http://g-images.amazon.com/images/G/01/detail/stars-'.$rating.'.gif" id="rate" />';
*/
	switch ($size) {
		case "s":
			$size = "90";
			$style = "tool-s";
			$length = "100";
			break;
		case "m":
			$size = "120";
			$style = "tool-m";
			$length = "100";
			break;
		case "l":
		default:
			$size = "160";
			$style = "tool-l";
			$length = "130";
			break;
	}
	$pcoff = array();
	if ($product["off"] && $tool["refresh"] == 1) {
		switch ($tool["pcoff"]) {
			case "1":
				$pcoff["img"] = '_PD'.sprintf("%02d", $product["off"]);
				break;	
			case "2":
				$pcoff["img"] = '_PE'.sprintf("%02d", $product["off"]);
				break;	
			default:
				$pcoff["img"] = "";
				break;	
		}
		switch ($tool["txtoff"]) {
			case "1":
				$pcoff["txt"] = '<b id="pcoff">'.$product["off"].'% OFF</b>';
				break;
			default:
				$pcoff["txt"] = "";
				break;
		}
	}
	$image = ($product["image"]) ? $product["image"].'._AA'.$size.$pcoff["img"].'_.jpg' : 'img/noimage'.$size.'.gif';
	if ($product["release"]) $product["release"] = ' ('.$product["release"].')';
	$html = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=Utf-8" />
<meta http-equiv="content-style-type" content="text/css" />
<meta name="generator" content="アメンボ" />
<meta name="robots" content="noindex,follow" />
<title>Amazon.co.jp: '.$product["title"].' | Powered by アメンボ</title>
<link rel="stylesheet" href="css/tool.css" type="text/css" />
<link rel="stylesheet" href="css/'.$style.'.css" type="text/css" />
</head>
<body>
<a href="'.$asinlink.'" target="'.$common["target"].'"><img src="'.$image.'" alt="'.$product["title"].'" title="'.$product["title"].'" id="pimage" width="'.$size.'" height="'.$size.'" /></a>
<div id="desc">
<p id="item"><strong><a href="'.$asinlink.'" target="'.$common["target"].'">'.mb_strimwidth($product["title"], 0, $length, "...", "utf-8").'</a></strong></p><p id="maker">'.$product["maker"].' '.$product["release"].'</p>';
	if ($tool["refresh"] == 1 && $product["status"]) {
		$html .= '<p id="price">';
		if ($product["rrp"] && $product["off"]) $html .= '<s>￥'.number_format($product["rrp"]).'</s> ';
		//if ($product["rrp"] && $product["rrp"] != $product["price"] && $product["price"]) $html .= '<s>￥'.number_format($product["rrp"]).'</s> ';
		if (!$product["price"]) $product["price"] = $product["rrp"];
		$html .= '<strong>￥'.number_format($product["price"]).'</strong> '.$pcoff["txt"].'<br />
	<b>'.$product["avail"].'</b></p>';
	}
$html .= '<a href="'.$asinlink.'" target="'.$common["target"].'" id="detail"><img src="img/amazon.gif" width="86" height="16" border="0" alt="Amazon で詳しく見る" title="Amazon で詳しく見る" /></a>'.$credit.'
</div>
</body>
</html>';
	return $html;
}

function amnbo_format_record($str) {
	$search = array("　", "（", "）", '"', "'");
	$replace = array(" ", " (", ") ", '”', "’");
	$str = str_replace($search, $replace, $str);
	$str = preg_replace("/\s+/", " ", $str);
	$str = trim($str);
	return $str;
}
?>
